import bpy,os,mathutils
from mathutils import Vector
from bpy.types import Operator
from bpy_extras.io_utils import ImportHelper
from bpy.props import StringProperty
#filename = 'C:/TMBlender/Ble279/Expressions/expression.txt'

def main(filename):
    scn = bpy.data.scenes[0]
    arms = bpy.context.selected_objects
    arm_ob = arms[0]
    if arm_ob.type != 'ARMATURE':
        print('No armature selected')
        return
    pbones = arm_ob.pose.bones
    fd = open(filename,'r')
    running = True
    while running:
        txt = fd.readline()
#print('txt = ',txt)
        txt = txt.rstrip()
#print('txt = ',txt)
        if len(txt) == 0:
            print('EOF')
            running = False
        if txt == '':
            running = False
        else:
            inv = txt.split('\t')
#print('inv = ',inv)
            col1 = inv[0]
            x = float(inv[1])
            y = float(inv[2])
            z = float(inv[3])
            print('%s %10.6f %10.6f %10.6f'%(col1,x,y,z))
            pbone = pbones[col1]
            loc = Vector((x,y,z))
            pbone.location = loc
    
class TheMoviesExpressionImporter(Operator, ImportHelper):
    bl_idname = "object.expression_import"   #
    bl_label = "Import TM Expression"
    filename_ext = "*.txt"
    filter_glob = StringProperty(
        default="*.txt",
        options={'HIDDEN'},
        maxlen=255,
    )
    def execute(self,context):
        main(self.filepath)
        return {'FINISHED'}
def menu_func_import(self,context):
    self.layout.operator(TheMoviesExpressionImporter.bl_idname,text="Import Expression (*.txt)"
)
def register():
    bpy.utils.register_class(TheMoviesExpressionImporter)
    bpy.types.INFO_MT_file_import.append(menu_func_import)
def unregister():
    bpy.utils.unregister_class(TheMoviesExpressionImporter)
    bpy.types.INFO_MT_file_import.remove(menu_func_import)
if __name__ == "__main__":
    register()
