#
#  Export an expression to a txt file.
#
import bpy,os
from mathutils import Vector
from bpy.types import Operator
from bpy_extras.io_utils import ImportHelper
from bpy.props import StringProperty


def export_expression(filename,arm_ob):
    print('Exporting expression.')
    pbones = arm_ob.pose.bones
    fd = open(filename,'w')
    for pbone in pbones:
        if 'fa_' in pbone.name:
            print('export ',pbone.name)
            loc = pbone.location
            fd.write('%s\t%10.6f\t%10.6f\t%10.6f\n'%(pbone.name,loc[0],loc[1],loc[2]))
    fd.close()
            
def main(filename):
#    scn = bpy.data.scenes[0]
#    arms = bpy.context.selected_objects
    arm_ob = bpy.context.scene.objects.active
    if arm_ob.type == 'ARMATURE':
        export_expression(filename,arm_ob)
    else:
        print('No armature selected')
class TheMoviesExpressionExporter(Operator, ImportHelper):
    """Export a TM face pose"""
    bl_idname = "object.expression_export"   #
    bl_label = "Export TM Expression"
    filename_ext = "*.txt"
    filter_glob = StringProperty(
        default="*.txt",
        options={'HIDDEN'},
        maxlen=255,
    )
    def execute(self,context):
        main(self.filepath)
        return {'FINISHED'}
def menu_func_export(self,context):
    self.layout.operator(TheMoviesExpressionExporter.bl_idname,text="Export Expression (*.txt)"
)
def register():
    bpy.utils.register_class(TheMoviesExpressionExporter)
    bpy.types.INFO_MT_file_export.append(menu_func_export)
def unregister():
    bpy.utils.unregister_class(TheMoviesExpressionExporter)
    bpy.types.INFO_MT_file_export.remove(menu_func_export)
if __name__ == "__main__":
    register()
