import bpy,os,mathutils,math
from mathutils import Vector, Euler
from bpy.types import Operator
from bpy_extras.io_utils import ImportHelper
from bpy.props import StringProperty
#filename = 'C:/TMBlender/Ble279/Expressions/expression.txt'
d2r = math.pi/180.0
def main(filename):
    scn = bpy.data.scenes[0]
    arms = bpy.context.selected_objects
    print('len(arms)= ',len(arms))
    arm_ob = arms[0]
    if arm_ob.type != 'ARMATURE':
        print('No armature selected')
        return
    pbones = arm_ob.pose.bones
    fd = open(filename,'r')
    running = True
    while running:
        txt = fd.readline()
#print('txt = ',txt)
        txt = txt.rstrip()
#print('txt = ',txt)
        if len(txt) == 0:
            print('EOF')
            running = False
        if txt == '':
            running = False
        else:
            inv = txt.split('\t')
#print('inv = ',inv)
            col1 = inv[0]
            x = d2r*float(inv[1])
            y = d2r*float(inv[2])
            z = d2r*float(inv[3])
            print('%s %10.6f %10.6f %10.6f'%(col1,x,y,z))
            pbone = pbones[col1]
#            pbone.rotation_mode = 'XYZ'
            rot = Euler((x,y,z)).to_quaternion()
            pbone.rotation_quaternion = rot
#            pbone.rotation_mode = 'QUATERNION'
    
class TheMoviesPoseImporter(Operator, ImportHelper):
    """Import a TM body pose from a text file"""
    bl_idname = "object.pose_import"   #
    bl_label = "Import TM Pose"
    filename_ext = "*.pose"
    filter_glob = StringProperty(
        default="*.pose",
        options={'HIDDEN'},
        maxlen=255,
    )
    def execute(self,context):
        main(self.filepath)
        return {'FINISHED'}
def menu_func_import(self,context):
    self.layout.operator(TheMoviesPoseImporter.bl_idname,text="Import Pose (*.pose)"
)
def register():
    bpy.utils.register_class(TheMoviesPoseImporter)
    bpy.types.INFO_MT_file_import.append(menu_func_import)
def unregister():
    bpy.utils.unregister_class(TheMoviesPoseImporter)
    bpy.types.INFO_MT_file_import.remove(menu_func_import)
if __name__ == "__main__":
    register()
