"""
Utility forimporting 

"""


# Import Modules
import bpy,os
import mathutils
from mathutils import *
from bpy.types import Operator
from bpy_extras.io_utils import ImportHelper
from bpy.props import StringProperty
#from Blender import Image, Material, Texture, Window, Armature
#from Blender import Mesh, NMesh, Group
#from Blender import Ipo
#from Blender.Mathutils import *
#import struct, os, math, time
#import tmConst
#import pdb

# Initialize viseme table
#quat = Quaternion(1.,0.,0.,0.)
#loc = Vector(0.,0.,0.)                
def quat_mult(r,q):
    p0 = r[0]*q[0]-r[1]*q[1]-r[2]*q[2]-r[3]*q[3]
    p1 = r[0]*q[1]+r[1]*q[0]-r[2]*q[3]+r[3]*q[2]
    p2 = r[0]*q[2]+r[1]*q[3]+r[2]*q[0]-r[3]*q[1]
    p3 = r[0]*q[3]-r[1]*q[2]+r[2]*q[1]+r[3]*q[0]
    p = Blender.Mathutils.Quaternion(p0,p1,p2,p3)
    return p
def read_viseme(name):
    fd = open(visemepath+'\\'+name+'.txt','r')
    running = True
    visemes[name] ={}
    while running:
        txt = fd.readline()
        if len(txt) == 0:
            print('EOF')
            running = False
        if txt == '':
            running = False
        else:
            inv = txt.split('\t')
            bone = inv[0]
            loc = Vector((float(inv[1]),float(inv[2]),float(inv[3])))
            visemes[name][bone] = loc
    fd.close()
def load_moho (filename):
    global visemes,visemepath
#   create empty viseme dictionary
    filepath = os.path.dirname(filename)
    visemepath = filepath+'\\visemes'
    visemes = {}
    read_viseme('AI')
    read_viseme('E')
    read_viseme('etc')
    read_viseme('FV')
    read_viseme('L')
    read_viseme('MBP')
    read_viseme('O')
    read_viseme('rest')
    read_viseme('U')
    read_viseme('WQ')
    stream = open(filename,"r")
    filepath = os.path.dirname(filename)
    filebase = os.path.basename(filename)
    fullbase = os.path.splitext(filebase)[0]
    basename = fullbase[0:21] #Blender has a $%$@ 21-char limit!
    basedir = os.path.split(filepath)[0]
    frames = []
    posecodes = []
    input = stream.readline()
    if 'MohoSwitch1' in input:
        print('This is a MOHO file.')
    else :
        print('This is not a MOHO file.  Goodbye.')
        return 
    input = stream.readline()
    while len(input)>0: 
        inv = str.rsplit(input)
        keyframe = int(inv[0])
        posecode = inv[1]
 #       print keyframe,posecode 
        frames += [keyframe]
        posecodes += [inv[1]]
        input = stream.readline()    
    scene = bpy.data.scenes[0]
    #scene.setLayers([1])

    #Check for armatures
    arms = bpy.data.armatures
    if len(arms) == 0:
        raise ValueError('No armatures selected')
#        block = []
#        block.append("No armature found.")
#        block.append("Importing points only.")
#        retval = Blender.Draw.PupBlock("WARNING", block)
 # make  a list of bone names in order
 #
    bns = []
    bns += ['fa_mouth_l_top']                 #      0
    bns += ['fa_mouth_top']                   #      1
    bns += ['fa_mouth_r_corner']              #      2
    bns += ['fa_mouth_bot']                   #      3             
    bns += ['fa_jaw']                         #      4
    bns += ['fa_mouth_r_corner_outer']        #      5
    bns += ['fa_mouth_r_bot']                 #      6
    bns += ['fa_mouth_l_corner_outer']        #      7
    bns += ['fa_mouth_r_top']                 #      8
    bns += ['fa_mouth_l_corner']              #      9
    bns += ['fa_mouth_l_bot']                 #     10
    bns += ['fa_adams_apple']                 #     11
    scn = bpy.data.scenes[0]
#    print "length = ",len(arms)
    arm_ob = bpy.context.active_object
    if arm_ob.type != 'ARMATURE':
        for ob in bpy.data.objects:
            if ob.type == 'ARMATURE':
                arm_ob = ob
    print('arm_ob = ',arm_ob.name)
#    print arm_ob
#    arm_data = arm_ob.getData()
#    print arm_data
#    arm_data.makeEditable()
#    bones= arm_data.bones.values()
#    print bones
#    pose = arm_ob.getPose()
#    print pose
    pbones = arm_ob.pose.bones
#    act = Blender.Armature.NLA.NewAction()
#    act.setActive(arm_ob)
 #   ostream = open('c:\TMBlender\Animation\ANM\debug_import.txt','w')
    btag = 0
    nf = len(frames)
#    dbg = open('d:/TMBlender/Ble279/LipSyncing/dbug.txt','w')
    f1 = scene.frame_start
    f2 = scene.frame_end
    for btag in range(len(bns)):
            for pbone in pbones:
                if bns[btag] == pbone.name:
                    scene.frame_current = f1
                    pbone.keyframe_insert('location')
                    scene.frame_current = f2
                    pbone.keyframe_insert('location')
                    scene.frame_current = f1
                    for f in range(nf):
                        frame = frames[f] + f1-1
                        scene.frame_current = frame
                        posecode = posecodes[f]
                        loc = visemes[posecode][pbone.name]   
#                        pbone.rotation_quaternion = Quaternion((quat[0],quat[1],quat[2],quat[3]))
                        pbone.location = Vector((loc[0],loc[1],loc[2]))
#                        dbg.write('bone = %s f = %3d frame = %3d code = %s\n'%(pbone.name,f,frame,posecode))
#                        dbg.write('quat = %10.6f %10.6f %10.6f %10.6f\n'%(quat[0],quat[1],quat[2],quat[3]))
#                        dbg.write('loc  = %10.6f %10.6f %10.6f\n'%(loc[0],loc[1],loc[2]))
                        print('\nframe = ',frame)
                        print('bone = ',pbone.name)
#                        print('quat = ',quat)
#                        print('loc = ',pbone.location)
                        pbone.keyframe_insert('rotation_quaternion')
                        pbone.keyframe_insert('location')
                    loc = visemes['MBP'][pbone.name]
#                     pbone.rotation_quaternion = Quaternion((quat[0],quat[1],quat[2],quat[3]))
                    pbone.location  = Vector((loc[0],loc[1],loc[2]))
#                     pbone.keyframe_insert('rotation_quaternion')
                    pbone.keyframe_insert('location')
            btag += 1
    print( 'basedir = ',basedir)            
#    context = scene.getRenderingContext()
#    context.startFrame(1)
#    context.endFrame(framecount)
#    print('sample fa_jaw')
#    print(visemes['AI']['fa_jaw']

#***********************************************
# register callback
#***********************************************
#def my_callback(filename):
#    gmt = time.gmtime()
#    print '%4d/%2d/%2d %2d:%2d:%2d'%(gmt[0],gmt[1],gmt[2],gmt[3],gmt[4],gmt[5])
#    load_moho(filename)

#Blender.Window.FileSelector(my_callback, "Import Moho switch data", '*.dat')
class TheMoviesMohoImporter(Operator, ImportHelper):
    """Import a moho file for a TM head"""
    bl_idname = "object.moho_import"   #
    bl_label = "Import moho for TM"
    filename_ext = "*dat"
    filter_glob = StringProperty(
        default="*.dat",
        options={'HIDDEN'},
        maxlen=255,
    )
    def execute(self,context):
        load_moho(self.filepath)
        return {'FINISHED'}
def menu_func_import(self,context):
    self.layout.operator(TheMoviesMohoImporter.bl_idname,text="Import Moho (*.dat)"
)
def register():
    bpy.utils.register_class(TheMoviesMohoImporter)
    bpy.types.INFO_MT_file_import.append(menu_func_import)
def unregister():
    bpy.utils.unregister_class(TheMoviesMohoImporter)
    bpy.types.INFO_MT_file_import.remove(menu_func_import)
if __name__ == "__main__":
    register()

