import bpy,mathutils
from mathutils import *
def main():
    active_obj = bpy.context.scene.objects.active
    print('active_obj = ',active_obj.name)
    bones = active_obj.pose.bones
    bl = ['hand_r','thumb_r','thumb2_r','fingers_r','fingers2_r']
    for b in bl:
        bone = bones[b]
        bone.rotation_mode = 'XYZ'
        print('b = ',bone.name,bone.rotation_euler)
    print('Now set the fingers')
    bones['hand_r'].rotation_euler = Euler((0.,0.,0.))
    bones['thumb_r'].rotation_euler = Euler((0,0,0))
    bones['thumb2_r'].rotation_euler = Euler((-0.0431,-0.1903,0.4481))
    bones['fingers_r'].rotation_euler = Euler((0.9350,0.0148,-0.0003))
    bones['fingers2_r'].rotation_euler = Euler((1.2392,0.0182,0.0104))

"""
b =  hand_l <Euler (x=0.0000, y=-0.0000, z=0.0000), order='XYZ'>
b =  thumb_l <Euler (x=0.0000, y=-0.0000, z=0.0000), order='XYZ'>
b =  thumb2_l <Euler (x=-0.0431, y=-0.1903, z=0.4481), order='XYZ'>
b =  fingers_l <Euler (x=-0.9350, y=0.0148, z=-0.0003), order='XYZ'>
b =  fingers2_l <Euler (x=-1.2392, y=0.0182, z=0.0104), order='XYZ'>
"""
class TMRightGrasp(bpy.types.Operator):
    """ close the right hand around an object """
    bl_idname = "object.right_grasp"
    bl_label = "Right Grasp"
    bl_info = "Look in console for output"
    def execute(self,context):
        main()
        return {'FINISHED'}
def register():
    bpy.utils.register_class(TMRightGrasp)
    print('Installed: tm right grasp')
if __name__ == '__main__':
    register()
