import bpy
def main():
    bpy.data.worlds["World"].light_settings.use_environment_light = True
    images = bpy.data.images
    for image in images:
        image.colorspace_settings.name = 'sRGB'
        image.use_alpha = False
        if 'com_' in image.name:
            image.use_alpha = True
    for mat in bpy.data.materials:
        mat.diffuse_intensity = 1   
        mat.emit = 0.0
        mat.ambient = .8
        mat.use_transparency = False
        mat.use_shadows = False
        mat.use_raytrace = True
    bpy.data.worlds['World'].light_settings.ao_factor = 1.0
    for ob in bpy.data.objects:
        if ob.type == 'MESH':
            ob.select = True
            bpy.context.scene.objects.active = ob
            bpy.ops.object.shade_smooth()
            ob.data.auto_smooth_angle = 3.14*80.0/180.0
class TMMeshSettings(bpy.types.Operator):
    """Initialize mesh & materials"""
    bl_idname = "object.mesh_settings"
    bl_label = "Mesh & Material Settings"
    bl_info = "Initialize Mesh and Material Settings"
    def execute(self,context):
        main()
        return {'FINISHED'}
def menu_func_import(self,context):
    self.layout.operator(TMMeshSettings)
def register():
    bpy.utils.register_class(TMMeshSettings)
    print('Installed: tm_mesh_settings')

if __name__ == '__main__':
    register()

    

    
    
    
