import bpy


class LayoutDemoPanel(bpy.types.Panel):
    """Creates a Panel in the scene context of the properties editor"""
    bl_label = "TM Utility Scripts"
    bl_idname = "SCENE_PT_layout"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "scene"

    def draw(self, context):
        layout = self.layout

        scene = context.scene

        # Create a simple row.
#        layout.label(text=" Simple Row:")

        row = layout.row()
        row.prop(scene, "frame_start")
        row.prop(scene, "frame_end")
        row.prop(scene, "frame_current")

        # Create an row where the buttons are aligned to each other.
#        layout.label(text=" Aligned Row:")

#        row = layout.row(align=True)
#        row.prop(scene, "frame_start")
#        row.prop(scene, "frame_end")

        # Create two columns, by using a split layout.
#        split = layout.split()

        # First column
#        col = split.column()
#        col.label(text="Column One:")
#        col.prop(scene, "frame_end")
#        col.prop(scene, "frame_start")

#        # Second column, aligned
#        col = split.column(align=True)
#        col.label(text="Column Two:")
#        col.prop(scene, "frame_start")
#        col.prop(scene, "frame_end")

        # Utility Buttons
        layout.label(text="The Movies Utility Scripts:")
        row = layout.row()
#        row.scale_y = 2.0
#        row.operator("render.render")
        row.operator("object.preflight_test")
        row = layout.row()
        row.operator("object.apply_move")
        row = layout.row()
        row.operator("object.mesh_settings")
        row = layout.row()
        row.operator("object.retimer")
        row = layout.row()
        row.operator("object.extender")
        row = layout.row()
        row.operator("object.left_grasp")
        row = layout.row()
        row.operator("object.right_grasp")
        row = layout.row()
        row.operator("object.sew_head")
        # Different sizes in a row
#        layout.label(text="Different button sizes:")
#        row = layout.row(align=True)
#        row.operator("render.render")

#        sub = row.row()
#        sub.scale_x = 2.0
#        sub.operator("render.render")

#        row.operator("render.render")


def register():
    bpy.utils.register_class(LayoutDemoPanel)


def unregister():
    bpy.utils.unregister_class(LayoutDemoPanel)


if __name__ == "__main__":
    register()
